package es.uv.garcosda.services;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jms.annotation.JmsListener;
import org.springframework.stereotype.Service;

import es.uv.garcosda.domain.File;
import es.uv.garcosda.domain.Mail;
import jakarta.jms.JMSException;
import jakarta.jms.Message;

@Service
public class ReceiverService {

	Logger log = LoggerFactory.getLogger(ReceiverService.class);
	
	@Autowired
	UserService us;
	
	@JmsListener(destination = "${mailer.queue}")
	public void receiveMails(Message message) {
		try {
			Mail m = message.getBody(Mail.class);
			log.info("Received: " + m);
			us.addMail(m);
		} 
		catch (JMSException e) {
			e.printStackTrace();
		}
	}
	
	@JmsListener(destination = "${files.queue}")
	public void receiveFiles(Message message) {
		try {
			File m = message.getBody(File.class);
			log.info("Received: " + m);
			us.addFile(m);
		} 
		catch (JMSException e) {
			e.printStackTrace();
		}
	}
}
